//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Orange
#property indicator_width1  2

//
//
//
//
//

extern int    Length            = 14;
extern int    Price             = PRICE_CLOSE;
extern double DiscardDeviation  = 10;
extern double DiscardMean       = 10;
double adev[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,adev);
      Length = MathMax(Length,2);
      IndicatorShortName("Absolute deviation of truncated mean ( "+Length+", "+DoubleToStr(DiscardDeviation,2)+"%, "+DoubleToStr(DiscardMean,2)+"% )");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
            int limit=MathMin(Bars-counted_bars,Bars-1);
 
   //
   //
   //
   //
   //
 
   for(int i=limit; i>=0; i--)
   {
      double price   = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double mean    = iTruncatedMean(price,Length,DiscardMean,i,0);
             adev[i] = iTruncatedMean(MathAbs(price-mean),Length,DiscardDeviation,i,1);
   }               
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workTrm[][2];
double sortTrm[];
double iTruncatedMean(double price, int period, double truncate, int i, int instanceNo=0)
{
   
   //
   //
   //
   //
   //
   
      if (ArraySize(sortTrm)!=period)  ArrayResize(sortTrm,period);
      if (ArrayRange(workTrm,0)!=Bars) ArrayResize(workTrm,Bars); int r = Bars-i-1;
                     workTrm[r][instanceNo] = price; for (int k=0; k<period; k++) sortTrm[k] = workTrm[r-k][instanceNo];
          ArraySort(sortTrm);
                  
      //
      //
      //
      //
      //
                           
      truncate =MathMax(MathMin(truncate,49),0);
         double temp  = period*truncate/100.0;
         int    start = 0; for( ; temp>1; ){ start++; temp -=1; }
         int    total = period-2*start;
            sortTrm[       start  ] = sortTrm[       start  ]*(1.0-temp)+sortTrm[       start-1]*temp;
            sortTrm[period-start-1] = sortTrm[period-start-1]*(1.0-temp)+sortTrm[period-start  ]*temp;
         double sum = 0;   for (k=0; k<total; k++) sum+= sortTrm[k+start];
         return(sum/total);         
}